mod imp;

use glib::Object;
use gtk::{
    gio, glib::{self, subclass::types::ObjectSubclassIsExt}, Application, Button, Image, prelude::*
};

glib::wrapper! {
    pub struct MemoryCardsNewScene(ObjectSubclass<imp::MemoryCardsNewScene>)
        @extends gtk::ApplicationWindow, gtk::Window, gtk::Widget,
        @implements gio::ActionGroup, gio::ActionMap, gtk::Accessible, gtk::Buildable,
                    gtk::ConstraintTarget, gtk::Native, gtk::Root, gtk::ShortcutManager;
}

impl MemoryCardsNewScene {
    pub fn new(app: &Application) -> Self {
        Object::builder().property("application", app).build()
    }

    pub fn get_file_choose_button(&self) -> &Button {
        self.imp().file_choose_button.as_ref()
    }

    pub fn get_image_widget(&self) -> &Image {
        self.imp().image.as_ref()
    }

    pub fn get_hieroglyph_input(&self) -> String {
        self.imp().heiroglyph_entry.text().to_string()
    }

    pub fn get_reading_input(&self) -> String {
        self.imp().reading_entry.text().to_string()
    }

    pub fn get_done_button(&self) -> &Button {
        self.imp().done_button.as_ref()
    }
}
